"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var react_use_1 = require("react-use");
var isEmpty_1 = __importDefault(require("lodash-es/isEmpty"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Avatar_1 = require("@steroidsjs/core/ui/content/Avatar");
var typography_1 = require("@steroidsjs/core/ui/typography");
var Title_1 = __importDefault(require("@steroidsjs/core/ui/typography/Title"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var timeTemplatesAndUnits_1 = require("@steroidsjs/core/ui/content/Chat/constants/timeTemplatesAndUnits");
var utils_1 = require("@steroidsjs/core/ui/content/Chat/utils");
require("./BubbleMessageView.scss");
var ChatFileItem_1 = __importDefault(require("../ChatFileItem"));
function BubbleMessageView(props) {
    var _a, _b;
    var bem = (0, useBem_1["default"])('BubbleMessageView');
    var isMessageByAnotherUser = !props.isCurrentUser;
    var _c = (0, react_1.useState)(props.timeAgo), timeAgo = _c[0], setTimeAgo = _c[1];
    (0, react_use_1.useInterval)(function () { return setTimeAgo((0, utils_1.calculateMessageTimeAgo)(props.timestamp)); }, props.isTodayMessage ? timeTemplatesAndUnits_1.SECONDS_IN_MINUTE_VALUE : null);
    return (react_1["default"].createElement("div", { className: bem.block({
            'another-user': isMessageByAnotherUser,
            'last-message': !!props.isLastMessage
        }) },
        react_1["default"].createElement("div", { className: bem.element('user-message') },
            !props.isCurrentUser && props.isFirstMessage && (react_1["default"].createElement(Title_1["default"], { className: bem.element('username'), type: 'h4', tag: 'h4', content: "".concat(props.user.firstName, " ").concat(props.user.lastName) })),
            react_1["default"].createElement(typography_1.Text, { className: bem.element('text'), type: "body", content: props.text }),
            !(0, isEmpty_1["default"])(props.files) && (react_1["default"].createElement("div", { className: bem.element('files') }, props.files.map(function (file) { return (react_1["default"].createElement(ChatFileItem_1["default"], __assign({ key: file.uid, isFileByAnotherUser: isMessageByAnotherUser, isFileFromMessage: true }, file))); }))),
            react_1["default"].createElement("div", { className: bem.element('indicators') },
                react_1["default"].createElement(typography_1.Text, { className: bem.element('time'), type: "body3", content: timeAgo }),
                props.isCurrentUser && (react_1["default"].createElement(Icon_1["default"], { className: bem.element('check'), name: "done-all" })))),
        props.user && (react_1["default"].createElement("div", { className: bem.element('avatar') },
            react_1["default"].createElement(Avatar_1.Avatar, { src: (_a = props.user.avatar) === null || _a === void 0 ? void 0 : _a.src, title: "".concat(props.user.firstName, " ").concat(props.user.lastName), status: (_b = props.user.avatar) === null || _b === void 0 ? void 0 : _b.status, size: 'sm' })))));
}
exports["default"] = (0, react_1.memo)(BubbleMessageView);
