"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var typography_1 = require("@steroidsjs/core/ui/typography");
var format_1 = require("@steroidsjs/core/ui/format");
require("./ChatFileItemView.scss");
function ChatFileItemView(props) {
    var _a, _b;
    var bem = (0, hooks_1.useBem)('ChatFileItemView');
    var isLoading = props.progress && props.progress.percent !== 100;
    var renderLink = react_1["default"].useCallback(function () {
        var _a;
        return (react_1["default"].createElement("a", { className: bem.element('link'), title: props.title, href: props.error ? '#' : (props.url || ((_a = props.item) === null || _a === void 0 ? void 0 : _a.url)), target: 'blank' }, props.title));
    }, [bem, props.title, props.error, props.url, (_a = props.item) === null || _a === void 0 ? void 0 : _a.url]);
    var renderProgressBar = react_1["default"].useCallback(function () { return (react_1["default"].createElement("div", { className: bem.element('progress-track') },
        react_1["default"].createElement("div", { className: bem.element('progress-bar'), style: { width: "".concat(props.progress.percent, "%") } }))); }, [bem, props.progress]);
    var renderLoadingState = react_1["default"].useCallback(function () { return (react_1["default"].createElement("div", { className: bem.element('left') },
        react_1["default"].createElement("div", { className: bem.element('icon-wrapper', 'loading') },
            react_1["default"].createElement(Icon_1["default"], { className: bem.element('icon-loading'), name: 'loading_default' })),
        react_1["default"].createElement("div", { className: bem.element('content') },
            react_1["default"].createElement("span", { className: bem.element('title', 'loading') }, props.title),
            renderProgressBar()))); }, [bem, props.title, renderProgressBar]);
    var renderFileItem = react_1["default"].useCallback(function () {
        var _a;
        return (react_1["default"].createElement("div", { className: bem.element('left') },
            react_1["default"].createElement("div", { className: bem.element('icon-wrapper') },
                react_1["default"].createElement(Icon_1["default"], { className: bem.element('icon'), name: (((_a = props.item) === null || _a === void 0 ? void 0 : _a.fullHeight) || props.fullHeight) ? 'img_box' : 'file_dock' })),
            react_1["default"].createElement("div", { className: bem.element('content') },
                react_1["default"].createElement(typography_1.Text, { type: 'boldSpan', content: props.title, className: bem.element('title') }),
                renderLink(),
                react_1["default"].createElement(typography_1.Text, { type: 'body2', className: bem.element('size'), color: 'light' },
                    react_1["default"].createElement(format_1.FileSize, { value: props.size, showZero: true })))));
    }, [bem, props.fullHeight, (_b = props.item) === null || _b === void 0 ? void 0 : _b.fullHeight, props.size, props.title, renderLink]);
    return (react_1["default"].createElement("div", { className: bem.block({
            error: !props.isFileFromMessage && !!props.error,
            isFileFromMessage: props.isFileFromMessage,
            isFileForUploading: !props.isFileFromMessage,
            'another-user': !!props.isFileByAnotherUser
        }) },
        isLoading
            ? renderLoadingState()
            : renderFileItem(),
        props.isFileFromMessage ? (react_1["default"].createElement(Icon_1["default"], { name: 'import', className: bem.element('download'), onClick: function () { return window.open(props.downloadUrl || props.url); } })) : (react_1["default"].createElement(Icon_1["default"], { name: props.customRemoveIcon || 'cross_8x8', className: bem.element('remove', { isLoading: isLoading }), onClick: props.onRemove }))));
}
exports["default"] = ChatFileItemView;
