"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var hooks_1 = require("@steroidsjs/core/hooks");
var react_1 = require("react");
function DropDownView(props) {
    var bem = (0, hooks_1.useBem)('DropDownView');
    var ui = (0, hooks_1.useComponents)().ui;
    var arrowRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        props.calculatePosition(props.forwardedRef.current.getBoundingClientRect(), props.hasArrow ? arrowRef.current.getBoundingClientRect() : null);
    }, [props.calculatePosition]);
    var contentProps = (0, react_1.useMemo)(function () { return ({
        onClose: props.onClose
    }); }, [props.onClose]);
    var content;
    if (props.content) {
        content = props.content();
        if ((0, isFunction_1["default"])(content)) {
            content = ui.renderView(content, contentProps);
        }
    }
    return (React.createElement("div", { ref: props.forwardedRef, className: bem(bem.block({
            show: props.isComponentVisible,
            position: props.position
        }), props.className), style: props.style },
        props.hasArrow && (React.createElement("div", { ref: arrowRef, className: bem.element('arrow', { position: props.position }), style: props.arrowPosition })),
        React.createElement("div", { className: bem.element('content') },
            React.createElement("span", null, content))));
}
exports["default"] = DropDownView;
