"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var content_1 = require("@steroidsjs/core/ui/content");
var react_1 = require("react");
var PADDING_WITH_ICON = 0;
var PADDING_WITHOUT_ICON = 24;
function TreeItemView(props) {
    var bem = (0, useBem_1["default"])('TreeItemView');
    var paddingBasedOnIcon = props.item.hasItems ? PADDING_WITH_ICON : PADDING_WITHOUT_ICON;
    var onExpandProps = (0, react_1.useMemo)(function () { return ({
        onClick: props.item.onClick,
        onKeyDown: function (e) { return e.key === 'Enter' && props.item.onClick(e); },
        role: 'button',
        tabIndex: 0
    }); }, [props.item]);
    return (React.createElement("div", __assign({ key: props.item.uniqueId, className: bem(bem.block({
            selected: props.item.isSelected,
            opened: props.item.isOpened,
            'has-items': props.item.hasItems,
            level: props.item.level,
            disabled: props.item.disabled
        }), props.className), style: {
            paddingLeft: "".concat(props.item.level * props.levelPadding + paddingBasedOnIcon, "px")
        } }, (!props.hasIconExpandOnly && onExpandProps)),
        props.item.hasItems && (React.createElement(content_1.Icon, __assign({ name: 'expand_right', className: bem.element('icon', {
                opened: props.item.isOpened
            }) }, (props.hasIconExpandOnly && onExpandProps)))),
        React.createElement("div", { className: bem.element('item') }, props.children)));
}
exports["default"] = TreeItemView;
